<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.view.MobileGatewayUser"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponse"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponseCode"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceRequest"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointDatabaseException"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointNetworkException"%>
<%@ page import="com.invoqsystems.apex.web.exceptions.AlarmPointTimeOutException"%>
<%@ page import="com.alarmpoint.servicemanager.*"%>

<%@ include file="includes/mobilegatewaysession.jsp"%>
<%
//Update the incident with all the changes
ServiceManagerIncident incident = (ServiceManagerIncident)session.getAttribute("incident");
if(incident != null){
  for(String key: incident.getOriginalMap().keySet()){
    if(request.getParameterValues(key) != null && request.getParameterValues(key).length == 2)
      incident.addUpdate(key, "true");
    else if(request.getParameter(key) != null)
      incident.addUpdate(key, (String)request.getParameter(key));
    else if(request.getParameter(key+"-DATE") != null)
      incident.addUpdate(key, XMLDateParser.getXMLDate((String)request.getParameter(key+"-DATE")));
  }
}

String action = request.getParameter("action");
if("create".equalsIgnoreCase(action))
//We are trying to create a new incident
{
  ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
  ExternalServiceResponse resps;
  esr.setAction("createIncident");
  esr.addToken("incident", incident);
  %> 
  <%@ include file="includes/sendRequest.jsp"%>
  <%
  String incidentID = null;
  String status = null;
  if(resps.getResponse() == null)
  {
    status = "failed to create incident";
  }
  else if(resps.getResponse() instanceof String)
  {
    status = (String)resps.getResponse();
  }
  else if(resps.getResponse() != null)
  {
    String[] rtn = (String[])resps.getResponse();
    incidentID = rtn[0];
    status = rtn[1];
  }

  if(status != null)
  {
    status = "?errorMessage="+status;
    %>
    <jsp:forward page="<%=response.encodeURL("createIncident.jsp"+status)%>"/>
    <%
  }
  else
  {
    status = "&message=Success";
    %>
    <jsp:forward page="<%=response.encodeURL("loadIncident.jsp?IncidentID="+incidentID+status)%>"/>
    <%
  }
}
else if("update".equalsIgnoreCase(action))
//We are trying to save the updated incident
{
  //Add processing for required fields
  //If we close a ticket we need FixType CloseCode and Resolution
  if("Closed".equals(incident.getTextValue("Status"))){
    String reqMessage = "";
    if("".equals(incident.getTextValue("ClosureCode")) || incident.getTextValue("ClosureCode") == null){
      if(!"".equals(reqMessage))
        reqMessage += ",";
      reqMessage += " Closure Code";
    }
    if("[]".equals(incident.getTextValue("Resolution")) || incident.getTextValue("Resolution") == null){
      if(!"".equals(reqMessage))
        reqMessage += ",";
      reqMessage += " Solution";
    }
    if(!"".equals(reqMessage)){
      reqMessage = "The following fields are required to close a ticket:" + reqMessage;
      %>
      <jsp:forward page="<%=response.encodeURL("updateIncident.jsp?tab=add_resolution&errorMessage="+reqMessage)%>"/>
      <%
    }
  }
  %>
  <jsp:forward page="<%=response.encodeURL("diffIncident.jsp")%>"/>
  <%
}
else if("go".equalsIgnoreCase(action))
//We are trying to navigate to another page
{
%>
  <jsp:forward page="<%=response.encodeURL(request.getParameter("menuURL"))%>"/>
<%
}
else
{
  Enumeration<String> parameterNames = request.getParameterNames();
  while(parameterNames.hasMoreElements())
  {
    String field = parameterNames.nextElement();
    String key = field.replaceFirst(".*-", "");
    String pageURL = request.getParameter("pageURL");
    String tab = request.getParameter("tab");

    if(field.startsWith("searchOperator"))
    {
      String searchString = "";
      if("AssigneeName".equalsIgnoreCase(key))
      {
        searchString = "&searchField=assignment.groups";
        searchString += "&searchOperator=EQUALS";
        searchString += "&searchValue="+incident.getTextValue("PrimaryAssignmentGroup");
      }
      String searchUrl = "searchOperators.jsp?url="+pageURL+"&tab="+tab+"&field="+key+searchString;
      %>
        <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
      <%
    }
    else if(field.startsWith("searchAssignments"))
    {
      String searchUrl = "searchAssignments.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
      %>
        <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
      <%
    }
    else if(field.startsWith("searchService"))
    {
      String searchUrl = "searchService.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
      %>
        <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
      <%
    }  
    else if(field.startsWith("searchSubcategory"))
    {
      String searchString = "";
      if("Subcategory".equalsIgnoreCase(key))
      {
        searchString = "&searchField=category";
        searchString += "&searchOperator=EQUALS";
        searchString += "&searchValue="+incident.getTextValue("Category");
      }
      String searchUrl = "searchSubcategory.jsp?url="+pageURL+"&tab="+tab+"&field="+key+searchString;
      %>
        <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
      <%
    }
    else if(field.startsWith("searchProductType"))
    {
      String searchString = "";
      if("ProductType".equalsIgnoreCase(key))
      {
        searchString = "&searchField=subcategory";
        searchString += "&searchOperator=EQUALS";
        searchString += "&searchValue="+incident.getTextValue("Subcategory");
      }
      String searchUrl = "searchProductType.jsp?url="+pageURL+"&tab="+tab+"&field="+key+searchString;
      %>
        <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
      <%
    }
    else if(field.startsWith("searchConfigItem"))
    {
      String searchUrl = "searchConfigItem.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
      %>
        <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
      <%
    }
    else if(field.startsWith("searchResolutionCode"))
    {
      String searchUrl = "searchResolutionCode.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
      %>
        <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
      <%
    }
    else if (field.startsWith("searchLocation"))
    {
        String searchUrl = "searchLocation.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
        %>
          <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
        <%
    }
  }
}
%>
