<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*"%>

<jsp:useBean class="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession" id="mobileGatewaySession" scope="session" />

<html>
  <head>
    <title>xMatters mobile access</title>
    <link rel="SHORTCUT ICON" href="/mg/images/logos/xmatters/favicon.ico" type="image/x-icon" />

    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="Cache-Control" content="max-age=0" />
    <meta http-equiv="Pragma" content="no-cache" />
    <meta http-equiv="Expires" content="-1" />
    <!-- IE Mobile Meta Tag (optimized for 100% of the screen width) -->
    <meta name="MobileOptimized" content="100" />

    <style type="text/css" media="all" title="xMatters mobile access">
      @import url("/mg/css/general.css");
      div.section-header {
        font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;
        font-size: 1.3em;
        font-weight: bold;
        background-color: #4180CE;
        color: #FFF;
        text-align: center;
        border: solid #666;
        border-width: 1px 1px 2px 1px;
        padding: 3px 2px 3px 2px;
      }
    </style>
  </head>

  <body>
    <div id="header">
      <img src="/mg/images/misc/spacer.gif" height="35" width="100" id="logo" name="logo" alt="xMatters mobile access" border="0" align="right" />
      <H1>Query Help</H1>
    </div>
    <div id="content">
      <div class="section-header">Steps</div>
      <p>To search for incidents:</p>
      <table>
        <tr>
          <td>1</td>
          <td>In the Field drop-down list, select an incident detail.</td>
        </tr>
        <tr>
          <td>2</td>
          <td>In the Op drop-down list, select a search operator. (See list of Operators below.)</td>
        </tr>
        <tr>
          <td>3</td>
          <td>In the Value field, type a string or other Service Manager style qualification. (See list of Qualification Styles below.)</td>
        </tr>
        <tr>
          <td>4</td>
          <td>Repeat for additional incident details and values to narrow your search results.</td>
        </tr>
        <tr>
          <td>5</td>
          <td>Click Submit Query.</td>
        </tr>
      </table>
      <div class="msg-warning">Note: Query results include only those incidents that match ALL specified search criteria.</div>
      <div class="section-header">Operators</div>
      <table>
        <tr>
          <th>Op</th>
          <th>Description</th>          
        </tr>
        <tr>
          <td>eq</td>
          <td>Equals</td>
        </tr>
        <tr>
          <td>not</td>
          <td>Not Equals</td>
        </tr>
        <tr>
          <td>begins</td>
          <td>Begins</td>
        </tr>
        <tr>
          <td>like</td>
          <td>Like</td>
        </tr>
      </table>
      <div class="section-header">Qualification Styles</div>
      <table>
        <tr>
          <th>Strings</th>
          <td>Strings must not be enclosed in quotation marks; e.g., Urgent.</td>
        </tr>
        <tr>
          <td></td>
          <td>Wildcards (represented by the * character) are supported only with the 'like' operator.</td>
        </tr>
        <tr>
          <th>Keywords</th>
          <td>Keywords and numbers should not be enclosed in quotation marks.</td>
        </tr>
      </table>
      <div class="section-header">List Items</div>
      <div class="msg-warning">Incident details that are lists cannot be searched using the "like" operator, but items within the lists can be represented using their respective IDs, as described in the following tables.</div>
      <table>
        <tr>
          <th colspan="2">Impact</th>
        </tr>
        <tr>
          <td>1-Enterprise</td>
          <td>1</td>
        </tr>
        <tr>
          <td>2-Site/Dept</td>
          <td>2</td>
        </tr>
        <tr>
          <td>3-Multiple Users</td>
          <td>3</td>
        </tr>
        <tr>
          <td>4-User</td>
          <td>4</td>
        </tr>
        <tr>
          <th colspan="2">Urgency</th>
        </tr>
        <tr>
          <td>1 - Critical</td>
          <td>1</td>
        </tr>
        <tr>
          <td>2 - High</td>
          <td>2</td>
        </tr>
        <tr>
          <td>3 - Average</td>
          <td>3</td>
        </tr>
        <tr>
          <td>4 - Low</td>
          <td>4</td>
        </tr>
      </table>
      <div class="section-header">Examples</div>
      <table>
        <tr>
          <th colspan="2">Example 1: Querying for all incidents in assignment group Service Manager</th>
        </tr>
        <tr>
          <th>Field</th>
          <td>Asgn Group</td>
        </tr>
        <tr>
          <th>Op</th>
          <td>eq</td>
        </tr>
        <tr>
          <th>Value</th>
          <td>Service Manager</td>
        </tr>
      </table>
      <table>
        <tr>
          <th colspan="2">Example 2: Querying for all incidents of Critical Impact </th>
        </tr>
        <tr>
          <th>Field</th>
          <td>Impact</td>
        </tr>
        <tr>
          <th>Op</th>
          <td>eq</td>
        </tr>
        <tr>
          <th>Value</th>
          <td>1</td>
        </tr>
        <tr>
          <td colspan="2">Note: Impact is compared using its list ID, where Critical has Impact value of 1.</td>
        </tr>
      </table>
      <table>
        <tr>
          <th colspan="2">Example 3: Querying for incidents that are related to E-mail</th>
        </tr>
        <tr>
          <th>Field</th>
          <td>Service</td>
        </tr>
        <tr>
          <th>Op</th>
          <td>begins</td>
        </tr>
        <tr>
          <th>Value</th>
          <td>E-mail</td>
        </tr>
      </table>
      <table>
        <tr>
          <th colspan="2">Example 4: Querying for incidents that are in a data sub-area</th>
        </tr>
        <tr>
          <th>Field</th>
          <td>Sub-area</td>
        </tr>
        <tr>
          <th>Op</th>
          <td>like</td>
        </tr>
        <tr>
          <th>Value</th>
          <td>*data*</td>
        </tr>
        <tr>
          <td colspan="2">Note: The * character is interpreted as a wildcard.</td>
        </tr>
      </table>
      <table>
        <tr>
          <th colspan="2">Example 5: Querying for incidents that are assigned to Incident.Coordinator</th>
        </tr>
        <tr>
          <th>Field</th>
          <td>Assignee</td>
        </tr>
        <tr>
          <th>Op</th>
          <td>not</td>
        </tr>
        <tr>
          <th>Value</th>
          <td>Incident.Coordinator</td>
        </tr>
      </table>
      <div class="msg-warning">For more information, see the Service Manager WorkFlow Objects manual.</div>
      <a href="<%=response.encodeURL("queryIncidents.jsp")%>">Back</a>
    </div>
    <jsp:include page="includes/footer.jsp"/>
  </body>
</html>
