<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*"%>
<%@ page import="java.net.URLEncoder" %>
<%@ page import="com.alarmpoint.apex.mobilegateway.view.MobileGatewayUser"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponse"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponseCode"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceRequest"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointDatabaseException"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointNetworkException"%>
<%@ page import="com.invoqsystems.apex.web.exceptions.AlarmPointTimeOutException"%>
<%@ page import="com.alarmpoint.servicemanager.*"%>

<%@ include file="includes/mobilegatewaysession.jsp"%>
<%!
private String encode(String value)
{
	if (value == null)
		return null;
	return URLEncoder.encode(value);
}
%>

<%
Map<String, String> searchFields = new LinkedHashMap<String, String>();
searchFields.put("logical.name", "Name");
%>

<!DOCTYPE html PUBLIC "-//OMA//DTD XHTML Mobile 1.0//EN" "http://www.openmobilealliance.org/tech/DTD/xhtml-mobile10.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>xMatters mobile access</title>
    <link rel="SHORTCUT ICON" href="/mg/images/logos/xmatters/favicon.ico" type="image/x-icon" />

    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="Cache-Control" content="max-age=0" />
    <meta http-equiv="Pragma" content="no-cache" />
    <meta http-equiv="Expires" content="-1" />
    <!-- IE Mobile Meta Tag (optimized for 100% of the screen width) -->
    <meta name="MobileOptimized" content="100" />

    <style type="text/css" media="all" title="xMatters mobile access">
      @import url("/mg/css/general.css");
      label.required {
      	font-weight: bold;
      	color: #990033;
      }
    </style>
  </head>

  <body>
    <%
    String field = (String)request.getParameter("field");
    String url = (String)request.getParameter("url");
    String tab = (String)request.getParameter("tab");
    %>
    <form name="form" action="<%=response.encodeURL("searchService.jsp?field="+field+"&url="+url+"&tab="+tab)%>" method="POST">
      <div id="header">
        <img src="/mg/images/misc/spacer.gif" height="35" width="100" id="logo" name="logo" alt="xMatters mobile access" border="0" align="right" />
        <h1>Search Service</h1>
      </div>
      <div id="content">
      
        <%
        if(request.getParameter("service") != null && url != null && field != null)
        {
          String service = (String)request.getParameter("service");
          if(session.getAttribute("incident") != null)
          {
            ServiceManagerIncident incident = (ServiceManagerIncident)session.getAttribute("incident");
            incident.addUpdate("Service", service);
          }
          %>
          <jsp:forward page="<%=response.encodeURL(url+"?tab="+tab)%>"/>
          <%
        }
        else if(request.getParameter("searchValue") != null && !"".equals(request.getParameter("searchValue")))
        {
          ServiceManagerQuery smQuery = new ServiceManagerQuery();
          ServiceManagerQueryField queryField = new ServiceManagerQueryField();
          queryField.setName((String)request.getParameter("searchField"));
          queryField.setOperator(ServiceManagerQueryOperator.valueOf((String)request.getParameter("searchOperator")));
          queryField.setValue((String)request.getParameter("searchValue"));
          smQuery.addQueryField(queryField);
          
          ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
          ExternalServiceResponse resps;
          esr.setAction("getValueMap");

          esr.addToken("operation","RetrieveBizserviceListRequest");
          esr.addToken("query", smQuery.getQuery());
          %> 
          <%@ include file="includes/sendRequest.jsp"%>
          <%
          if(resps.getResponse() instanceof String)
          {
              out.print("<div class=\"msg-error\">"+resps.getResponse()+"</div>");
          }
          else
          {
            Collection<Map<String, String>> services = (Collection)resps.getResponse();
            if(services.isEmpty())
            {
              out.print("<div class=\"msg-warning\">No Results Found</div>");
            }
            else
            {
              %>
              <table>
                <tr>
                  <th>Service</th>
                </tr>
                <%
                for(Map<String, String> service : services)
                {
                  %>
                  <tr>
                    <td><a href="<%=response.encodeURL("searchService.jsp?field="+field+"&url="+url+"&tab="+tab+"&service="+encode(service.get("Name")))%>"><%=service.get("Name")%></a></td>
                  </tr>
                  <%
                }
                %>
              </table>
            <%
            }
            %>
            <a href="<%=response.encodeURL("searchService.jsp?field="+field+"&url="+url+"&tab="+tab)%>">Search Again</a>
            <%
          }
        }
        else
        {
          %>
          <table>
            <tr>
              <th>Field</th>
              <th>Op</th>
              <th>Value</th>
            </tr>
            <tr>
              <td>
                <select name="searchField">
                  <%
                  for(String fld : searchFields.keySet())
                  {
                  %>
                  <option value="<%=fld%>"><%=searchFields.get(fld)%></option>
                  <%
                  }
                  %>
                </select>
              </td>
              <td>
                <select name="searchOperator">
                  <%
                  for(ServiceManagerQueryOperator operator : ServiceManagerQueryOperator.values())
                  {
                  %>
                  <option value="<%=operator.toString() %>"><%=operator.getShortName()%></option>
                  <%
                  }
                  %>
                </select>
              </td>
              <td>
                <input type="text" name="searchValue" size="10" value="*"/>
              </td>
            </tr>
          </table>
          <i>Search is case sensitive</i><br>
          <input type="submit" name="search" value="Search"/>
          <%
        }
        %> 
      </div>
    </form>
    <a href="<%=response.encodeURL(url+"?tab="+tab)%>">Back to Details</a>

    <jsp:include page="includes/footer.jsp"/>
  </body>
</html>
