<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.view.MobileGatewayUser"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponse"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponseCode"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceRequest"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointDatabaseException"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointNetworkException"%>
<%@ page import="com.invoqsystems.apex.web.exceptions.AlarmPointTimeOutException"%>
<%@ page import="com.alarmpoint.servicemanager.*"%>

<%@ include file="includes/mobilegatewaysession.jsp"%>
<%@ include file="configuration.jsp"%>

<!DOCTYPE html PUBLIC "-//OMA//DTD XHTML Mobile 1.0//EN" "http://www.openmobilealliance.org/tech/DTD/xhtml-mobile10.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>xMatters mobile access</title>
    <link rel="SHORTCUT ICON" href="/mg/images/logos/xmatters/favicon.ico" type="image/x-icon" />

    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="Cache-Control" content="max-age=0" />
    <meta http-equiv="Pragma" content="no-cache" />
    <meta http-equiv="Expires" content="-1" />
    <!-- IE Mobile Meta Tag (optimized for 100% of the screen width) -->
    <meta name="MobileOptimized" content="100" />

    <style type="text/css" media="all" title="xMatters mobile access">
      @import url("/mg/css/general.css");
      label.required {
      	font-weight: bold;
      	color: #990033;
      }
    </style>
  </head>

  <body>
    <a id="top" name="top"></a>

    <div id="header">
      <img src="/mg/images/misc/spacer.gif" height="35" width="100" id="logo" name="logo" alt="xMatters mobile access" border="0" align="right" />
      <h1>Service Manager Menu</h1>
    </div>

    <div id="content">
      <%
      MobileGatewayUser user = mobileGatewaySession.getUser();
      String smUser = (String)request.getParameter("smUser");
      String smPass = (String)request.getParameter("smPass");

      if(smUser == null)
        smUser = (String)session.getAttribute("smUser");
      if(smPass == null)
        smPass = (String)session.getAttribute("smPass");

      try{
        if(smUser == null)
          smUser = user.getCustomField(SM_USER_NAME_FIELD);
        if(smPass == null)
          smPass = user.getCustomField(SM_PASSWORD_FIELD);
      }catch(Exception e){
      }
      
      session.setAttribute("smUser", smUser);
      if(smPass == null)
        smPass = "";
      session.setAttribute("smPass", smPass);

      if(VERIFY_SM_CREDS && smUser != null)
      {
        ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
        ExternalServiceResponse resps;
        esr.setAction("validateCreds");
        %>
        <%@ include file="includes/sendRequest.jsp"%> 
        <%
        String failedMessage = (String)resps.getResponse();
        if(failedMessage != null)
        {
          smUser = null;
          session.removeAttribute("smUser");
          session.removeAttribute("smPass");
          out.print("<div class=\"msg-error\">"+failedMessage+"</div>");
        }
      }

      if(smUser == null)
      //Display SM Login Page
      {
      %>
      <form method="POST" action="<%=response.encodeURL("urlAlias.jsp?identifier="+request.getParameter("identifier"))%>">

        <table class="no-border">
          <tr>
            <td class="align-right"><label class="required">SM Login:</label></td>
            <td><input type="text" name="smUser"/></td>
          </tr>
          <tr>
            <td class="align-right"><label class="required">SM Password:</label></td>
            <td><input type="password" name="smPass"/></td>
          </tr>
          <tr>
            <td></td>
            <td><input type="submit" name="submit"/></td>
          </tr>
        </table>
      </form>
      <%
      }
      else
      {
        if(request.getParameter("newIncident") == null)
        {
          ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
          ExternalServiceResponse resps;
          esr.setAction("getIncident");
          esr.addToken("IncidentID", request.getParameter("IncidentID"));
          %> 
          <%@ include file="includes/sendRequest.jsp"%>
          <%
          if(resps.getResponse() instanceof String)
          {
            session.setAttribute("incident", null);
            %>
            <jsp:forward page="<%=response.encodeURL("updateIncident.jsp?errorMessage="+(String)resps.getResponse())%>"/>
            <%
          }
          else
          {
            ServiceManagerIncident incident = (ServiceManagerIncident)resps.getResponse();
            %> 
            <%@ include file="includes/initialize.jsp"%>
            <%
            if(incident != null){
              for(String key: incident.getOriginalMap().keySet()){
                if(request.getParameter(key) != null)
                  incident.addUpdate(key, (String)request.getParameter(key));
              }
            }
            session.setAttribute("incident", incident);
            %>
            <jsp:forward page="<%=response.encodeURL("updateIncident.jsp")%>"/>
            <%
          }
        }
        else
        {
          ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
          ExternalServiceResponse resps;
          ServiceManagerIncident incident = new ServiceManagerIncident();
          %> 
          <%@ include file="includes/initialize.jsp"%>
          <%
          if(incident != null){
            for(String key: incident.getOriginalMap().keySet()){
              if(request.getParameter(key) != null)
                incident.addUpdate(key, (String)request.getParameter(key));
            }
          }
          session.setAttribute("incident", incident);
          %>
          <jsp:forward page="<%=response.encodeURL("createIncident.jsp")%>"/>
          <%
        }
      }
      %>

    </div>

    <jsp:include page="includes/footer.jsp">
      <jsp:param name="menu" value="true" />
    </jsp:include>
  </body>
</html>
