<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*" %>
<%@ page import="com.invoqsystems.apex.web.cocoon.jsp.*" %>
<%@ page import="com.alarmpoint.servicemanager.ServiceManagerScriptObject" %>

<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<jsp:useBean id="subscriptionBean"
             class="com.invoqsystems.apex.web.cocoon.jsp.SubscriptionBeanImpl"
             scope="session" />

<jsp:useBean id="serviceManagerBean"
             class="com.alarmpoint.servicemanager.ServiceManagerScriptObject"
             scope="session" />


<%
  /**
   * You can change these following variables to match the correct information, if necessary.
   */
  final int MAX_DISPLAY_CHARACTERS = 60;
  final int MAX_RECIPIENT_DISPLAY_CHARACTERS = 80;
  final boolean QUERY_PREDICATE_VALUES = true;
  
  final String CATEGORY_PREDICATE_NAME = "category";
  final String SUBCATEGORY_PREDICATE_NAME = "subcategory";
  final String PRODUCT_TYPE_PREDICATE_NAME = "product_type";
  final String TRIGGER_RULE_PREDICATE_NAME = "trigger_rule";
  final String IMPACT_PREDICATE_NAME = "impact";
  final String SEVERITY_PREDICATE_NAME = "urgency";
  
  final String SERVICE_MANAGER_URL = "http://localhost:13080/sc62server/ws";
  final String SERVICE_MANAGER_USER = "falcon";
  final String SERVICE_MANAGER_PASSWORD = "";
  
  serviceManagerBean.initializeClient(SERVICE_MANAGER_URL, SERVICE_MANAGER_USER, SERVICE_MANAGER_PASSWORD);

%>


<subscription-panel xmlns:fi="http://apache.org/cocoon/forms/1.0#instance"
                    xmlns:i18n="http://apache.org/cocoon/i18n/2.1"
                    onload="onLoad();"
                    onsubmit="return validateForm(this);" >

<%
  // set up the map for storing the selected values for each predicate
  final HashMap<String, ArrayList<String>> selectedPredicateValuesMap = new HashMap<String, ArrayList<String>>();
  final HashMap<String, PredicateBean> predicateNameMap = new HashMap<String, PredicateBean>();
  final HashMap<String, String> predicateSummaryNamesMap = new HashMap<String, String>();

  final StringBuffer summaryName = new StringBuffer();
  // collect the selected predicate values, and pre-populated values
  Iterator<PredicateBeanImpl> iterator = subscriptionBean.getPredicateIterator();
  while(iterator.hasNext())
  {
     final PredicateBean predicate = iterator.next();
     ArrayList<String> selectedValues = new ArrayList<String>();
     selectedValues.addAll(predicate.getSelectedValues());

     selectedPredicateValuesMap.put(predicate.getPredicateName().toLowerCase(), selectedValues);
     predicateNameMap.put(predicate.getPredicateName().toLowerCase(), predicate);

     if(!predicate.getSelectedValues().isEmpty())
     {
       summaryName.delete(0, summaryName.length());
	   if(predicate.hasAnySelectedValue())
       {
         summaryName.append("ANY");
       }
	   else
	   {
         Iterator<String> valIter = predicate.getSelectedValues().iterator();
         while(valIter.hasNext())
         {
           summaryName.append(valIter.next());
           if(valIter.hasNext())
             summaryName.append(", ");
           if(summaryName.length() > MAX_DISPLAY_CHARACTERS)
           {
             summaryName.setLength(MAX_DISPLAY_CHARACTERS);
             break;
           }
         }
	   }
       predicateSummaryNamesMap.put(predicate.getPredicateName().toLowerCase(), summaryName.toString());
    }
  }

  final String subId = (String)request.getParameter("subscriptionId");
  final boolean creatingSubscription = subId == null || "0".equals(subId);

  /**
   * This tab count will contain the total number tabs that will be displayed.
   */
  // THe total number of tabs that will be displayed
  int tabCount = 5;
  if(creatingSubscription)
  {
    tabCount--;
  }
  if(subscriptionBean.isSelfSubscription())
  {
    tabCount--;
  }
  if(subscriptionBean.allOverridesSuppressed() && subscriptionBean.isTimeframeSuppressed())
  {
    tabCount--;
  }

  /**
   * This maps the tab position for each predicate.
   */
  final HashMap<String, String> predicateTabPositionMap = new HashMap<String, String>();
  predicateTabPositionMap.put(CATEGORY_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(SUBCATEGORY_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(PRODUCT_TYPE_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(IMPACT_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(SEVERITY_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(TRIGGER_RULE_PREDICATE_NAME, "1");    
  
  final HashMap<String, String> predicateLabelMap = new HashMap<String, String>();
  predicateLabelMap.put(CATEGORY_PREDICATE_NAME, "Category");
  predicateLabelMap.put(SUBCATEGORY_PREDICATE_NAME, "Area");
  predicateLabelMap.put(PRODUCT_TYPE_PREDICATE_NAME, "Sub-area");
  predicateLabelMap.put(IMPACT_PREDICATE_NAME, "Impact");
  predicateLabelMap.put(SEVERITY_PREDICATE_NAME, "Urgency");
  predicateLabelMap.put(TRIGGER_RULE_PREDICATE_NAME, "Trigger Rule");
  
  final List<String> detailPredicates = Arrays.asList(TRIGGER_RULE_PREDICATE_NAME, CATEGORY_PREDICATE_NAME, SUBCATEGORY_PREDICATE_NAME, PRODUCT_TYPE_PREDICATE_NAME, IMPACT_PREDICATE_NAME, SEVERITY_PREDICATE_NAME);
%>

<style media="screen" type="text/css">
  span.forms-tab {  	
    display: inline;
    position: relative;
    top: -1px;
    z-index: 1;
    overflow: hidden;
    font-weight: bold;    
  	text-decoration: none;
  	cursor: pointer;
    color: #555555;    
  	background: transparent url(/static/images/layout/main-menu-bg-off.gif) no-repeat top left;
  	padding: 6px 7px 1px 11px;
  	border-right: 1px solid #666;
    border-bottom: 1px solid #666;
    border-top: none;
    border-left: none;    
    margin: 0;
  }

  span.forms-tab:hover {  	
    background: transparent url(/static/images/layout/main-menu-bg-hover.gif) no-repeat top left;
  }

  span.forms-tab.forms-activeTab {
  	display: inline;
    position: relative;
    top: 1px;
    z-index: 10;    
    overflow: hidden; 
  	cursor: default;
    color: #000000;
    background: transparent url(/static/images/layout/main-menu-bg-selected.gif) no-repeat top left;
    padding: 7px 7px 1px 11px;
    border-bottom: none;
  }

  span.forms-tab.forms-activeTab:hover {
  	background-color: #FFF;
  	position: relative;
  }

  span.forms-tabContent {
  	background-color: #FFF;
  	border: 1px solid #666;
  	/*padding: 3em;*/
  	position: relative;
  	z-index: 2;
  }

  #sandbag-01,
  #sandbag-02 {
  	clear: left;
  	float: left;
  	padding: 0pt; /*border: 1px solid #0f0;*/
  }

  #sandbag-01 {
  	height: 10px;
  	width: 160px;
  }

  #sandbag-02 {
  	height: 10px;
  	width: 95px;
  }

  #refreshNodeButton, #refreshNodeGroupsButton {
  	line-height: 18px;
  	vertical-align: top;
  }

  #PREDICATE_VALUE_NODE, #PREDICATE_VALUE_NODE_GROUPS {
  	width: 115px;
  }

  label#matching {
  	font-weight: bold;
    width: 175px;
  }

  div.form-row label.summary {
  	font-weight: bold;
  	width: 0px;
  	float: none;
  	text-align: left;
  	vertical-align: middle;
  	padding: 0px 4px 0px 0px;
  	margin-left: 85px;
  }

  span.summary-row {
  	float: none;
  	text-align: left;
  	vertical-align: middle;
  	padding: 0px 0px 0px 0px;
  }

  span.summary-row span.summary-item {
  	float: none;
  	padding: 0px 5px 0px 0px;
  }

  span.elipse {
  	font-size: 11px;
  	color: #0000CC;
  	margin: 0px 0px 0px 5px;
  	padding: 0;
  	text-decoration: underline;
  	background-color: transparent;
  	border: none;
  	cursor: pointer;
  }

  div.form-row ul#summary_list {
  	margin-left: 100px;
  	padding: 0px 0px 0px 0px;
  }

  div.form-row ul#summary_list li {
  	display: list-item;
  	padding: 0px 3px 0px 0px;
  }

  div.form-row ul#summary_list li.summary_AND {
  	font-weight: bold;
  	list-style: none;
  	margin-left: 20px;
  }

  div.form-row ul#summary_list li.summary-item span.summary_text italic {
  	font-style: italic;
  }
</style>

<script type="text/javascript" language="JavaScript">
  var old_forms_showTab;
  function onLoad()
  {
   old_forms_showTab = forms_showTab;
   forms_showTab = new_forms_showTab;
   var lastTab = document.DefaultSubscriptionForm.currentTab.value;
  	if(window.location.hash == "#recipients")
  	  lastTab = 4;
   if(lastTab != null &amp;&amp; lastTab != "" &amp;&amp; lastTab != "null")
     forms_showTab("attributes", lastTab, 5, "");
  }
  
  function new_forms_showTab(tabgroup, idx, length, state)
  {
  	document.DefaultSubscriptionForm.currentTab.value = idx;
  	old_forms_showTab(tabgroup, idx, length, state);
  }
</script>

<h3>HP Service Manager 9.20 Incident Management</h3>
<br/>
<input type="hidden" name="currentTab" value="<%=request.getParameter("currentTab")%>" /> 

<text-widget id="name">
  <value><%= subscriptionBean.getName() %></value>
</text-widget>

<group label="Attributes">

<tab-group id="attributes">

<%
  if(!creatingSubscription)
  {
%>

    <tab-content id="summary_tab" label="Summary">
        <div class="form-row">
          <label id="matching">Matching Any Event Where</label>
        </div>
        <div class="form-row">
        <ul id="summary_list">
<%
  iterator = subscriptionBean.getPredicateIterator();
  boolean firstNonEmptyPredicate = true;
  while(iterator.hasNext())
  {
     final PredicateBean predicate = iterator.next();
     if(!predicate.getSelectedValues().isEmpty())
     {
       String summary = predicateSummaryNamesMap.get(predicate.getPredicateName().toLowerCase());
       String predPosition = predicateTabPositionMap.get(predicate.getPredicateName().toLowerCase());
%>
		     <% if(!firstNonEmptyPredicate) { %>
              <li class="summary_AND">
              <span class="summary_text">AND</span>
              </li>
             <%}%>

          <li class="summary-item">
            <span class="predicate_data"><%=predicateLabelMap.get(predicate.getPredicateName().toLowerCase())%></span>
			<span class="summary_text italic"> <%=predicate.getSelectedOperatorType()%></span>
            <span class="predicate_data"> (<%=summary%></span>
            <% if(summary.length() == MAX_DISPLAY_CHARACTERS) { %>
            <span class="elipse" onclick="forms_showTab('attributes', <%=predPosition%>, <%=Integer.toString(tabCount)%>, '')" >...</span>
            <% } %>
            <span class="summary_text">)</span>
          </li>
<%
	   firstNonEmptyPredicate = false;
     }
  }
%>
        </ul>
        </div>

        <div class="form-row">
          <label class="summary">Available:</label>
         <span class="summary-row">
<%
          if(subscriptionBean.isOnSunday())
          {
            out.print("<span class=\"summary-item\">Sun</span>");
          }
          if(subscriptionBean.isOnMonday())
          {
            out.print("<span class=\"summary-item\">Mon</span>");
          }
          if(subscriptionBean.isOnTuesday())
          {
            out.print("<span class=\"summary-item\">Tue</span>");
          }
          if(subscriptionBean.isOnWednesday())
          {
            out.print("<span class=\"summary-item\">Wed</span>");
          }
          if(subscriptionBean.isOnThursday())
          {
            out.print("<span class=\"summary-item\">Thu</span>");
          }
          if(subscriptionBean.isOnFriday())
          {
            out.print("<span class=\"summary-item\">Fri</span>");
          }
          if(subscriptionBean.isOnSaturday())
          {
            out.print("<span class=\"summary-item\">Sat</span>");
          }
%>

          <span class="summary-item"><%=subscriptionBean.getStartTime()%></span>
          <span class="summary-item">-</span>
          <span class="summary-item"><%=subscriptionBean.getEndTime()%></span>
        </span>
        </div>
        <div class="form-row">
          <label class="summary">Using:</label>
         <span class="summary-row">
<%
          if(subscriptionBean.hasAllDeviceFilter())
          {
            out.print("<span class=\"summary-item\">All Devices</span>");
          }
          else
          {
            ArrayList<String> types = subscriptionBean.getDeviceTypeOverrides();
            for(String type : types)
            {
%>
            <span class="summary-item"><%=type.substring(NotificationAPI.DEVICE_FILTER_FIELD_PREFIX.length())%></span>
<%
            }
          }
%>
          </span>
        </div>
<%
  if(!subscriptionBean.isSelfSubscription())
  {
%>
        <div class="form-row">
          <label class="summary">Targeting:</label>
         <span class="summary-row">
<%
         int charactersDisplayed = 0;
         ArrayList<String> recipients = subscriptionBean.getRecipients();
         for(String recipient : recipients)
         {
%>
            <span class="summary-item"><%=recipient%></span>
<%
           charactersDisplayed += recipient.length();
           if(charactersDisplayed > MAX_RECIPIENT_DISPLAY_CHARACTERS)
           {
             out.print("<span class=\"summary-item\">...</span>");
             break;
           }
         }
%>
          </span>
        </div>

<%
  }
%>

    </tab-content>

<%
  }
%>

    <tab-content id="details_tab" label="Incident Details">

<%
    for(String predicateName : detailPredicates){
      PredicateBean predicate = predicateNameMap.get(predicateName);
      ArrayList<String> selectedValues = selectedPredicateValuesMap.get(predicateName);
      
      if (predicate != null)
      {
%>
      <div class="form-row">
        <label class="widget" for="<%=predicate.getPredicateValueWidgetId()%>"><%=predicateLabelMap.get(predicateName)%>:</label>
        <span  id="<%=predicate.getPredicateValueWidgetId()%>">
          <select size="5" multiple="0" id="<%=predicate.getPredicateValueWidgetId()%>" name="<%=predicate.getPredicateValueWidgetId()%>" >
            <option value="<%=subscriptionBean.getAnyPredicateListValue() %>" <% if(selectedValues.contains(subscriptionBean.getAnyPredicateListValue()))out.print("selected=\"true\""); %> >-- ANY --</option>
<%
			Collection<String> values;
			if(QUERY_PREDICATE_VALUES && predicateName.equals(SUBCATEGORY_PREDICATE_NAME)){
			    values = serviceManagerBean.getSortedList("RetrieveSubcategoryListRequest", "active=true&category=\"Incident\"", "subcategory");
			}else if(QUERY_PREDICATE_VALUES && predicateName.equals(PRODUCT_TYPE_PREDICATE_NAME)){
			    values = serviceManagerBean.getSortedList("RetrieveProductTypeListRequest", "active=true&category=\"Incident\"", "product.type");
			}else{
			    values = predicate.getPredicateValues();
			}
			for (String name : values)
            {
%>
              <option value="<%= name%>" <% if(selectedValues.contains(name))out.print("selected=\"true\""); %> ><%= name%></option>
<%
            }
%>
           </select>
        </span>
      </div>
<%
      }
      else
      {
        out.println("<div class=\"system-msg-error\">Unexpected exception occurred: The value " + predicateName + " has not been defined as a predicate for the Event Domain on which this Subscription is based, or has not been added to the Subscription Domain.</div>"); 
      }
    }
%>

    </tab-content>

<%
  if(!subscriptionBean.allOverridesSuppressed() || !subscriptionBean.isTimeframeSuppressed())
  {
%>
    <tab-content id="pref_tab" label="Preferences">

      <subscription-timeframe group-label="Timeframe" />
      <subscription-overrides group-label="Overrides" />

    </tab-content>

<%} %>

<%
  if(!subscriptionBean.isSelfSubscription())
  {
%>
    <tab-content id="assigned_tab" label="Assign">

      <subscribed-recipients group-label="Recipients" />

    </tab-content>
<%
  }
%>

</tab-group>

</group>

</subscription-panel>
